(function () {
	var LINE_BREAK = "\n";

	window.StringBuilder = function () {
		var self = this,
			_parts = [];
		
		self.append = function (value) {
			_parts.push(value);
		};
		
		self.appendLine = function (value) {
			self.append(value + LINE_BREAK);
		};
		
		self.toString = function () {
			if (_parts.length > 1) {
				_parts = [_parts.join("")];
			}
			return _parts[0];
		};
		
		return self;
	};
	
	window.StringBuilder.CR_LINEBREAK = "\r";
	window.StringBuilder.LF_LINEBREAK = "\n";
	window.StringBuilder.CRLF_LINEBREAK = "\r\n";
	
	window.StringBuilder.setLineBreak = function (line) {
		LINE_BREAK = line;
	};
}());