describe("Map", function () {
	it("should work with any key", function () {
		var map = new Map();
		var obj1 = {a : 123};
		var obj2 = {b : 234};
		
		map.put(123, "foobar");
		map.put(obj1, "boom");
		map.put(obj2, "kaboom");
		
		expect(map.get(123)).toEqual("foobar");
		expect(map.get(obj1)).toEqual("boom");
		expect(map.get(obj2)).toEqual("kaboom");
	});
	
	it("should overwrite same key", function () {
		var map = new Map();
		
		map.put(123, "foo");
		map.put(123, "bar");
		
		expect(map.get(123)).toEqual("bar");
	});
	
	it("should not mix data type", function () {
		var map = new Map();
		
		map.put(123, "foo");
		map.put("123", "bar");
		
		expect(map.get(123)).toEqual("foo");
		expect(map.get("123")).toEqual("bar");
	});
});