describe("String Builder", function () {
	it("should be able to construct with new", function () {
		var sb = new StringBuilder();
		
		expect(sb.append).toBeDefined();
		expect(sb.appendLine).toBeDefined();
		expect(sb.toString).toBeDefined();
	});
	
	it("should be able to construct without new", function () {
		var sb = StringBuilder();
		
		expect(sb.append).toBeDefined();
		expect(sb.appendLine).toBeDefined();
		expect(sb.toString).toBeDefined();
	});
	
	it("should append string", function () {
		var sb = new StringBuilder();
		
		sb.append("123");
		sb.append("456");
		sb.append("789");
		
		expect(sb.toString()).toEqual("123456789");
	});
	
	it("should append line", function () {
		// LF line break //
		StringBuilder.setLineBreak(StringBuilder.LF_LINEBREAK);
		
		var sb = new StringBuilder();
		
		sb.appendLine("123");
		sb.appendLine("456");
		sb.appendLine("789");
		
		expect(sb.toString()).toEqual("123\n456\n789\n");
		
		// CR line break //
		StringBuilder.setLineBreak(StringBuilder.CR_LINEBREAK);
		
		var sb = new StringBuilder();
		
		sb.appendLine("123");
		sb.appendLine("456");
		sb.appendLine("789");
		
		expect(sb.toString()).toEqual("123\r456\r789\r");
		
		// CRLF line break //
		StringBuilder.setLineBreak(StringBuilder.CRLF_LINEBREAK);
		
		var sb = new StringBuilder();
		
		sb.appendLine("123");
		sb.appendLine("456");
		sb.appendLine("789");
		
		expect(sb.toString()).toEqual("123\r\n456\r\n789\r\n");
	});
	
	it("should append lots of string", function () {
		var sb = new StringBuilder();
		
		for (var i=0; i<100000; i++) {
			sb.append("a");
		}
		
		expect(sb.toString().length).toEqual(100000);
	});
});